; $Id: gcd.scm,v 1.3 2006/12/12 16:02:41 schimans Exp $

; renewed 06-02-27; diana ratiu
(set! COMMENT-FLAG #f)
(libload "nat.scm")
(set! COMMENT-FLAG #t)

(add-var-name "a" "b" "c" "r" (py "nat"))


;quot und rem sind quotient bzw. rest der Division zweier natuerlicher Zahlen
;lin(a1 a2 k1 k2) hat die Bedeutung |a1*a2-k1*k2|
;fun ist eine Funktion mit Bedeutung:
;    fun(a1 a2 k1 k2 q) = q*k1-1 falls k2*a2<k1*a1 und 0<q
;                         q*k1+1 sonst
;div prueft, ob zwei natuerliche Zahlen dividierbar sind

(add-program-constant "quot"  (py "nat=>nat=>nat") t-deg-one)
(add-program-constant "rem" (py "nat=>nat=>nat") t-deg-one)
(add-program-constant "lin" (py "nat=>nat=>nat=>nat=>nat") t-deg-one)
(add-program-constant "fun" (py "nat=>nat=>nat=>nat=>nat=>nat") t-deg-one)
(add-program-constant "div" (py "nat=>nat=>boole") t-deg-one)


;Beweis gcd

(aga "DivAlg" (pf "all a,b,c,r.a=b*c+r -> (0<r -> bot) -> div c a"))
(aga "DivAlgCor" (pf "all a,c.0<c -> a=(quot a c)*c+(rem a c)"))
(aga "RemCor" (pf "all a,c.0<c -> (rem a c)<c"))
(aga "RemRewr1" (pf "all a1,a2,k1,k2,b,r.a1=b*(lin k1 a1 k2 a2)+r 
                      -> (lin (fun a1 a2 k1 k2 b) a1 (b*k2) a2)=r"))
(aga "RemRewr2" (pf "all a1,a2,k1,k2,b,r.a2=b*(lin k1 a1 k2 a2)+r 
                                  -> (lin (b*k1) a1 (fun a2 a1 k2 k1 b) a2)=r"))
(aga "lemlin" (pf "all a,b.0<b -> 0<(lin 0 a 1 b)"))

;Beweis der Kleinerinduktion

(add-var-name "i" "j" "l" (py "nat"))

(set-goal
 (pf "all a1,a2.
              (all k1,k2.(all i,j.(lin i a1 j a2)<(lin k1 a1 k2 a2) 
                                    -> 0<(lin i a1 j a2) -> bot) 
                         -> 0<(lin k1 a1 k2 a2) -> bot) 
              -> all k1,k2.0<(lin k1 a1 k2 a2) -> bot"))
(assume "a1" "a2" "w1" "k1" "k2")

(use-with
 (pf "all n,k1,k2.(lin k1 a1 k2 a2)<n -> 0<(lin k1 a1 k2 a2) -> bot")
 (pt "(lin k1 a1 k2 a2)+1") (pt "k1") (pt "k2") "?")

;Beweis von der "cut-Formel"
(ind)

;Basis
(assume "k11" "k22" "h2" "h3")
(ng)
(use "Efq")
(prop)

;Schritt
(assume "n" "w2" "k11" "k22" "w3")
(use-with "w1" (pt "k11") (pt "k22") "?")
(assume "i" "j" "w4")
(use-with "w2" (pt "i") (pt "j") "?")
;"lem1" : (pf "all m,r,n.m<r -> r<n+1 -> m<n")
(use-with "NatLtLtSuccTrans" (pt "lin i a1 j a2") (pt "lin k11 a1 k22 a2") (pt "n") "w4" "w3")
(ng)(prop)
;(define kli-proof pproof)
(save "kli")

;Beweis des gcd mit globaler Annahme kli.
; (aga "kli" (pf "all lin. all a1,a2.
;               (all k1,k2.(all i,j.(lin i a1 j a2)<(lin k1 a1 k2 a2) 
;                                     -> 0<(lin i a1 j a2) -> bot) 
;                          -> 0<(lin k1 a1 k2 a2) -> bot)
;               -> all k1,k2.0<(lin k1 a1 k2 a2) -> bot"))
; nicht mehr nötig - die obene kann benutzt werden

(set-goal
 (pf "all a1,a2.0<a2 -> (all k1,k2.div(lin k1 a1 k2 a2)a1 
                                       -> div(lin k1 a1 k2 a2)a2 
                                       -> 0<(lin k1 a1 k2 a2) -> bot)
                         -> bot"))

(assume "a1" "a2" "u1" "u")
(use-with  
  (pf "all k1,k2.0<(lin k1 a1 k2 a2) -> bot") (pt "0") (pt "1") "?")
(use "kli")
(assume "k1" "k2" "u11" "u2")
(use "u" (pt "k1") (pt "k2"))

; "DivAlg" : (pf "all div. all a,b,c,r.a=b*c+r -> (0<r -> bot) -> div c a")
(use "DivAlg"  (pt "quot a1(lin k1 a1 k2 a2)")
             (pt "rem a1(lin k1 a1 k2 a2)"))
; Terme geliefert für b und r

(use-with "DivAlgCor"
   (pt "a1") (pt "lin k1 a1 k2 a2") "?")
(use "u2")
(assume "u3")
(use "u11" 
    (pt "fun a1 a2 k1 k2(quot a1(lin k1 a1 k2 a2))")
    (pt "(quot a1(lin k1 a1 k2 a2))*k2"))

; Ziel:  (lin(fun a1 a2 k1 k2(quot a1(lin k1 a1 k2 a2)))
;         a1((quot a1(lin k1 a1 k2 a2))*k2)a2)<(lin k1 a1 k2 a2) 

; "RemRewr1" : (pf "all lin, fun. all a1,a2,k1,k2,b,r.a1=b*(lin k1 a1 k2 a2)+r 
(simp-with "RemRewr1" 
          (pt "a1") (pt "a2") (pt "k1") (pt "k2")
	  (pt "quot a1(lin k1 a1 k2 a2)")
	  (pt "rem a1(lin k1 a1 k2 a2)")
	  "?") 
(use-with "RemCor" (pt "a1")
      (pt "lin k1 a1 k2 a2") "u2")
(use-with "DivAlgCor"
    (pt "a1") (pt "lin k1 a1 k2 a2") "u2")

(simp-with "RemRewr1"
          (pt "a1") (pt "a2") (pt "k1") (pt "k2")
	  (pt "quot a1(lin k1 a1 k2 a2)")
	  (pt "rem a1(lin k1 a1 k2 a2)")
	  "?")
(use "u3")
(use-with "DivAlgCor"
	  (pt "a1") (pt "lin k1 a1 k2 a2") "u2") 

(use "DivAlg" (pt "quot a2(lin k1 a1 k2 a2)") (pt "rem a2(lin k1 a1 k2 a2)"))
; b durch (pt "quot a2(lin k1 a1 k2 a2)")  ersetzt
; r durch (pt "rem a2(lin k1 a1 k2 a2) ersetzt

(use-with "DivAlgCor" 
	  (pt "a2") (pt "lin k1 a1 k2 a2") "u2")

(assume "u3")
(use "u11" (pt "(quot a2(lin k1 a1 k2 a2))*k1")
	  (pt "fun a2 a1 k2 k1(quot a2(lin k1 a1 k2 a2))"))

;Ziel: (lin((quot a2(lin k1 a1 k2 a2))*k1)
;       a1(fun a2 a1 k2 k1(quot a2(lin k1 a1 k2 a2)))a2)<(lin k1 a1 k2 a2)

;"RemRewr2" : (pf "all lin, fun. all a1,a2,k1,k2,b,r.a2=b*(lin k1 a1 k2 a2)+r 
(simp-with "RemRewr2" 
	  (pt "a1") (pt "a2") (pt "k1") (pt "k2")
	  (pt "quot a2(lin k1 a1 k2 a2)")
	  (pt "rem a2(lin k1 a1 k2 a2)")
	  "?")
(use-with "RemCor" 
	   (pt "a2") (pt "lin k1 a1 k2 a2") "u2")

(use-with "DivAlgCor" 
	  (pt "a2") (pt "lin k1 a1 k2 a2") "u2")

(simp-with "RemRewr2" 
	  (pt "a1") (pt "a2") (pt "k1") (pt "k2")
	  (pt "quot a2(lin k1 a1 k2 a2)")
	  (pt "rem a2(lin k1 a1 k2 a2)")
	  "?")
(use "u3")
(use-with "DivAlgCor" 
	  (pt "a2") (pt "lin k1 a1 k2 a2") "u2")
(use "u2") 

;v0: 0<(lin 0 a1 1 a2) from 0<a2
(use-with "lemlin" (pt "a1") (pt "a2") "u1")

;(define gcd-with-glob-kli pproof)
(save "gcd-with-glob-kli")

(define gcd
  (np (expand-theorems
       (theorem-name-to-proof "gcd-with-glob-kli"))))

(define reduced-gcd (np (reduce-efq-and-stab gcd)))


; A-Translation
(mload "../modules/atr.scm")

(define term
  (atr-min-excl-proof-to-structured-extracted-term reduced-gcd))
(pp term)

; [a1,a2]
;  ([a1,a2]
;    ([a1346,a1347,(nat=>nat=>nat@@nat)_1635](nat=>nat=>nat@@nat)_1635 0 1)a1 
;    a2
;    ([k1,k2]([k1,n1636]k1@n1636)k1(([k2]k2)k2)))
;  a1 
;  a2


(define nterm (nt term))
(pp nterm)

; [n0,n1]0@1
