; $Id: root.scm,v 1.2 2006/12/12 16:02:29 schimans Exp $

; We prove the existence of integer square roots.

(set! COMMENT-FLAG #f)
(libload "nat.scm")
(set! COMMENT-FLAG #t)

(add-var-name "f" "g" (py "nat=>nat"))

(set-goal (pf "all f,g,n.(all n.n<f 0 -> bot) -> 
                         all n n<f(g n) -> 
                         excl m.(n<f m -> bot) ! n<f(m+1)"))
(assume "f" "g" "n" 1 2 3)
(cut (pf "all m.n<f m -> bot"))
(search)
(ind)
(search)
(search)

; (dnp)
; (dnpe)

; (lambda (f)
;   (lambda (g)
;     (lambda (n)
;       (lambda (|13|)
;         (lambda (|14|)
;           (lambda (|15|)
;             ((((((|Ind| n) (lambda (n6) (f n6))) (|13| n)) |15|) (g n))
;              (|14| n))))))))

(define min-excl-proof (pproof-state-to-proof))
; (formula-to-string (fold-formula (proof-to-formula min-excl-proof)))
; "all f,g,n.(all n.n<f 0 -> bot) -> 
;            all n n<f(g n) -> 
;            excl m.(n<f m -> bot) ! n<f(m+1)"

(set! COMMENT-FLAG #f)
(mload "../modules/atr.scm")
(set! COMMENT-FLAG #t)

(define et (atr-min-excl-proof-to-structured-extracted-term min-excl-proof))

(term-to-string (nt et))
; [f0,f1,n2](Rec nat=>nat)0([n3,n4][if (n2<f0 n3) n4 n3])(f1 n2)

(define sqr (pt "[n]n*n"))

(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "3")))) ;"1"
(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "4")))) ;"2"
(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "8")))) ;"2"
(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "9")))) ;"3"
(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "15")))) ;"3"
(term-to-string (nt (mk-term-in-app-form et sqr (pt "Succ") (pt "16")))) ;"4"

; Alternative proof, using an axiomatized <=.  Assume
; 1: all n (f 0)<=n
; 2: all n n<f(g n)
; Then  there is an m such that f(m) <= n < f(m+1).
; For the proof one uses
; Lemma1: all n,m. (n<m -> F) -> m<=n 
; Lemma2: all n,m. n<m ->  m<=n -> F

; Similarly to < in lib/nat.scm, we add a program constant natLessEq
; (displayed as infix  <= ), with no rules.

; (add-program-constant
;  "natLessEq" (mk-arrow (make-alg "nat") (make-alg "nat") (make-alg "boole"))
;  1 'const 2)

; (add-token
;  "<="
;  'rel-op
;  (lambda (x y)
;    (mk-term-in-app-form
;     (make-term-in-const-form (pconst-name-to-pconst "natLessEq")) x y)))

; (add-display
;  (py "boole")
;  (lambda (x)
;    (let* ((op (term-in-app-form-to-final-op x))
; 	  (args (term-in-app-form-to-args x)))
;      (if (and (term-in-const-form? op)
; 	      (string=? "natLessEq"
; 			(const-to-name (term-in-const-form-to-const op)))
; 	      (= 2 (length args)))
; 	 (list 'rel-op "<="
; 	       (term-to-token-tree (car args))
; 	       (term-to-token-tree (cadr args)))
; 	 #f))))

; (aga "Lemma2" (pf "all n,m. n<m ->  m<=n -> F"))

; (define root
;   (pf "all f,g.all n f 0<=n -> 
;                all n n<f(g n) -> 
;                all n.(all m.f m<=n -> n<f(m+1) -> F) -> F"))

; (set-goal root)
; (assume "f" "g" 1 2 "n" 3)
; (use-with "Lemma2"
;           (pt "n") (pt "f(g n)") DEFAULT-GOAL-NAME DEFAULT-GOAL-NAME)
; (use 2)
; (cut (pf "all m f(m)<=n"))
; (assume 4)
; (use 4)
; (ind)
; (use 1)
; (assume "m" 4)
; (aga "Lemma1" (pf "all n,m. (n<m -> F) -> m<=n"))
; (use-with "Lemma1" (pt "n") (pt "f(m+1)") DEFAULT-GOAL-NAME)
; (use 3)
; (use 4)

; (rga "Lemma1" "Lemma2")
