; $Id: wftest.scm,v 1.4 2006/12/12 16:02:29 schimans Exp $

; We prove the existence of a "least" element in a well-founded set.

(set! COMMENT-FLAG #f)
(libload "nat.scm")
(set! COMMENT-FLAG #t)

(add-var-name "f" (py "nat=>nat"))

(set-goal (pf "all f.(all m.m<0 -> bot) -> excl k.f(k+1)<f k -> bot"))
(assume "f" 1)
(by-assume-minimal-wrt (pf "excl k T") "k" (pt "f") "k-Min" "k-Hyp")

(exc-intro (pt "0"))
(use "Truth-Axiom")

(assume "H1")
(use "H1" (pt "k"))
(assume "H2")
(use "k-Min" (pt "k+1"))
(use "H2")
(use "Truth-Axiom")

(define nproof (np (current-proof)))

; (proof-to-expr nproof)

; (lambda (f)
;   (lambda (u539)
;     (((|ExclElimTwoOne| f)
;       ((|MinPrlOneOne| f) ((|ExclIntroOneOne| 0) |Truth-Axiom|)))
;      (lambda (n565)
;        (lambda (u548)
;          (lambda (u549)
;            (lambda (u550)
;              ((u550 n565)
;               (lambda (u551)
;                 (((u548 (+ n565 1)) u551) |Truth-Axiom|))))))))))

; (cdp nproof)

(define nproof-without-exc (rm-exc nproof))

(set! COMMENT-FLAG #f)
(mload "../modules/atr.scm")
(set! COMMENT-FLAG #t)

(define nseterm
  (nt (atr-min-excl-proof-to-structured-extracted-term
       (np (reduce-efq-and-stab (expand-theorems nproof-without-exc))))))

; (term-to-expr nseterm)

; (lambda (f0)
;   (if (< (f0 1) (f0 0))
;       ((((natrec (lambda (n1) 0))
;          (lambda (n1)
;            (lambda (f2)
;              (lambda (n3)
;                (if (< (f0 (+ n3 1)) (f0 n3)) (f2 (+ n3 1)) n3)))))
;         (f0 0))
;        1)
;       0))

; Discussion: Rec defines a function h of type nat=>nat=>nat.  Let f :=
; f0.  After an initial check whether f 1<f 0, in the positive case a
; recursively defined binary function is applied to f 0 and 1.  This
; avoids applying h to 0 (and hence using dummy, where 0 =: dummy).
; More readable description of the algorithm:

; Point-of-increase f := [if (f 1<f 0) (h(f 0)1) 0] with

; h 0 := [m]dummy
; h(n+1) := [m] [if (f(m+1)<f m) (h n(m+1)) m]

; Notice that n is not used in the definition of h.  Reason: induction
; is used in the form of a minimum principle only.

(define arg (pt "[n][if (n=0) 2 n]"))
(term-to-string (nt (make-term-in-app-form nseterm arg)))
; "1"

(define arg (pt "[n][if (n=0) 4 [if (n=1) 3 n]]"))
(term-to-string (nt (make-term-in-app-form nseterm arg)))
; "2"
