; MINLOG: abbrev.scm

; Here we define some usefull abbreviations.


(display"

Begin of abbrev.scm

")


; pnt
(define(pnt string)(pp(nt(pt string))))



; TO ADD COMPUTATION AND RW-RULES






;;;   CUT

; ca
(define(ca formulastring string)
  (begin (cut(pf formulastring))
    (assume string)))


; cas
(define(cas formulastring string)
  (begin (cut(pf formulastring))
    (assume string)
    (simp string)))




;;; CASEDISTINCTION


; cd
(define(cd termstring string)
  (begin (cases(pt termstring))
    (assume string)))

; cds
(define(cds termstring string)
  (begin (cases(pt termstring))
    (assume string)
    (simp string)))






;;;   A MARKER

(define (th)
  (set! OLD-COMMENT-FLAG COMMENT-FLAG)
  (set! COMMENT-FLAG #t)
  (newline)
  (display "!!!!!!!!!!!  TILL HERE !!!!!!!!!!!!!!!!!!")
  (newline)
  (newline))






;;;   INFERENCE RULES

; alternate_quants alternats the two outermost quantifiers
; of the goal formula, provided they are equal.

(define (alternate_quants)
  (let ((gf (goal-to-formula(current-goal)))
	(err "alternate_quants: Goal formula must be an all-all-form or ex-ex-form !!!"))
    (set! OLD-COMMENT-FLAG COMMENT-FLAG)
    (set! COMMENT-FLAG #f)
    (cond ((all-form? gf)
	   (let* ((ggf (all-form-to-kernel gf)))
	     (if (all-form? ggf)
		 (let* ((var1 (all-form-to-var gf))
			(var2 (all-form-to-var ggf))
			(gggf (all-form-to-kernel ggf))
			(ngf (make-all var2 (make-all var1 gggf))))
		   (cut ngf)
		   (search))
		 (myerror err))))
	  ((ex-form? gf)
	   (let* ((ggf (ex-form-to-kernel gf)))
	     (if (ex-form? ggf)
		 (let* ((var1 (ex-form-to-var gf))
			(var2 (ex-form-to-var ggf))
			(gggf (ex-form-to-kernel ggf))
			(ngf (make-ex var2 (make-ex var1 gggf))))
		   (cut ngf)
		   (assume "ex21")
		   (ex-elim "ex21")
		   (drop "ex21")
		   (strip 1)
		   (assume "ex1")
		   (ex-elim "ex1")
		   (search))
		 (myerror err))))
	  (else (myerror err)))
    (set! COMMENT-FLAG OLD-COMMENT-FLAG)
    (dcg)))


;;; TO ANINMATE THMS

(define animate-list '())

(define (add-to-animate-list thm-name)
  (set! animate-list (cons thm-name animate-list)))

(define (animate-all-thms)
  (newline)
  (comment "We first deanimate all theorems.")
  (deanimate-all-thms)
  (set! ANIMATE-COMMENT-FLAG COMMENT-FLAG)
  (set! COMMENT-FLAG #f)
  (letrec ((animall
			(lambda (x)
			  (if (null? x)
				  (begin
					(newline)
					(set! COMMENT-FLAG ANIMATE-COMMENT-FLAG)
					(comment "All theorems are ANIMATED !"))
				  (begin
					(animate (car x))
					(animall (cdr x)))))))
	(animall animate-list)))


(define (deanimate-all-thms)
  (set! ANIMATE-COMMENT-FLAG COMMENT-FLAG)
  (set! COMMENT-FLAG #f)
  (letrec ((deanimall
			(lambda (x)
			  (if (null? x)
				  (begin
					(newline)
					(set! COMMENT-FLAG ANIMATE-COMMENT-FLAG)
					(comment "All theorems are DEANIMATED !"))
				  (begin
					(deanimate (car x))
					(deanimall (cdr x)))))))
	(deanimall animate-list)))



(display"

End of abbrev.scm

")
