; demo.scm
; 00-11-26

; 1. Free algebras
; ================

(add-sfas '("Uzero" nat)
          `("Usucc" ,(mk-arrow 'nat 'nat)))

(define (make-numeric-term n)
  (if (= n 0)
      (pt "Uzero")
      (make-term-in-app-form
       (pt "Usucc")
       (make-numeric-term (- n 1)))))

(av "n" "m" 'nat)

(add-token "$" 'prefix-op 
	   (lambda (x) (make-term-in-app-form (pt "Usucc") x)))

(add-program-constant "Dup" (mk-arrow 'nat 'nat) 1 1 'prefix-op)

(add-computation-rule (pt "Dup Uzero") (pt "Uzero"))
(add-computation-rule (pt "Dup (Usucc n)")
		      (pt "Usucc (Usucc (Dup n))"))

(dt (nt (pt "Dup Uzero")))
(dt (nt (pt "Dup (Usucc Uzero)")))
(dt (nt (pt "Dup (Usucc n)")))
(dt (nt (pt "Dup (Usucc(Usucc Uzero))")))
(dt (nt (pt "Dup (Usucc(Usucc(Usucc n)))")))

(dt (pt "3"))

(add-program-constant "+" (mk-arrow 'nat 'nat 'nat) 1 2 'add-op)

(add-computation-rule (pt "n + 0") (pt "n"))
(add-computation-rule (pt "n +  $m") (pt "$(n + m)"))

(dt (nt (pt "0 + 0")))
(dt (nt (pt "0 + n")))
(dt (nt (pt "0 +  $ $n")))

(set-goal (pf "all n3,n2,n1.n1 + (n2 + n3) = n1 + n2 + n3"))
(nat-ind)
(assume "n2" "n1")
(dcgnf)
(use "Truth")
(assume "n2" 1)
(use 1)

(set-goal (pf "all n 0 + n = n"))
(nat-ind)
(dcgnf)
(use "Truth")
(assume "n2" 1)
(dcgnf)
(use 1)
(dcpp)

(add-rewrite-rule (pt "0 + n") (pt "n"))

(set-goal (pf "all m,n.$n + m =  $(n + m)"))
(nat-ind)
(dcgnf)
(assume "n")
(use "Truth")
(assume "n2" 1)
(dcgnf)
(use 1)

(add-rewrite-rule (pt "$n + m") (pt "$(n + m)"))

(set-goal (pf "all n,m.n + m = m + n"))
(nat-ind)
(dcgnf)
(assume "m")
(use "Truth")
(assume "n2" 1)
(dcgnf)
(use 1)

(add-rewrite-rule (pt "n1 + (n2 + n3)") (pt "n1 + n2 + n3"))

(add-program-constant "*" (mk-arrow 'nat 'nat 'nat) 1 2 'mul-op)

(add-computation-rule (pt "n * 0") (pt "0"))
(add-computation-rule (pt "n * $m") (pt "(n * m) + n"))

(dt (nt (pt "0 * 0")))
(dt (nt (pt "0 * n")))
(dt (nt (pt "0 * $ $n")))
(dt (nt (pt "$n * $m")))

(set-goal (pf "all n 0 * n = 0"))
(nat-ind)
(use "Truth")
(assume "n2" 1)
(dcgnf)
(use 1)

(add-rewrite-rule (pt "0 * n") (pt "0"))

(add-rewrite-rule (pt "$n * m") (pt "(n * m) + m"))
(add-rewrite-rule (pt "n1 * (n2 * n3)") (pt "n1 * n2 * n3"))

(add-program-constant "<" (mk-arrow 'nat 'nat 'boole) 1 2 'rel-op)
(add-computation-rule (pt "n < 0") (pt "False"))
(add-computation-rule (pt "0 < $n") (pt "True"))
(add-computation-rule (pt "$n1 < $n2") (pt "n1 < n2"))

; translating the quotrem term: (recall that division is by n^1 + 1)
; [n^1]nat-rec(0@0)([n^3,nat*nat^4]
; [if (p_2 nat*nat^4)<n^1 then p_1 nat*nat^4 else 
; (p_1 nat*nat^4)+1]@([if (p_2 nat*nat^4)<n^1 then 
; (p_2 nat*nat^4)+1 else 0]))

(av "pairvar" (make-star 'nat 'nat))

(define qrterm
  (pt "[n0](RECat nat=>nat;nat)
             (Uzero @ Uzero)
             ([n2,pairvar3][if ((right pairvar3) < n0) 
                               (left pairvar3) 
                               (Usucc(left pairvar3))] @ 
                           [if ((right pairvar3) < n0) 
                               (Usucc(right pairvar3)) 
                               Uzero])"))
(dt (nt qrterm))
(dt (nt (make-term-in-app-form qrterm (pt "0"))))
(dt (nt (make-term-in-app-form qrterm (pt "1"))))
(dt (nt (mk-term-in-app-form qrterm (pt "2") (pt "10"))))

(d-type (type-of-rec-at (py "nat=>nat")))
(d-type (type-of-rec-at (py "nat=>boole")))
(d-type (type-of-rec-at (py "boole=>boole")))

; Examples for free algebras: words

(add-sfas '("Ewd" word)
          `("Cwd" ,(mk-arrow 'boole 'word 'word) pair-op))

(av "bs" "cs" 'word)
(av "ub" 'boole)

(dt (nt (pt "bs")))
(dt (nt (pt "ub Cwd cs")))
(dt (nt (pt "ub1 Cwd ub2 Cwd cs")))
(dt (nt (pt "True Cwd False Cwd Ewd")))

; Examples for free algebras: Trees and tree lists

(add-sfas
 '("Leaf" tree)
 `("Branch" ,(mk-arrow 'tlist 'tree))
 '("Empty" tlist)
 `("Tcons" ,(mk-arrow 'tree 'tlist 'tlist) pair-op))

(dt (nt (pt "Leaf Tcons Empty")))

(add-var-name "aas" "bbs" 'tlist)
(add-var-name "aa" "bb" 'tree)

(add-program-constant "treeadd" (mk-arrow 'tree 'tree 'tree) 1 2 'add-op)
(add-program-constant "tlistadd" (mk-arrow 'tlist 'tree 'tlist) 1 2 'add-op)

; As in section \ref{Pconst} of ea.tex we recursively define treeadd 
; and tlistadd.

(add-computation-rule (pt "Leaf treeadd aa") (pt "aa"))
(add-computation-rule (pt "(Branch bbs) treeadd aa")
		      (pt "Branch(bbs tlistadd aa)"))
(add-computation-rule (pt "Empty tlistadd aa") (pt "Empty"))
(add-computation-rule (pt "(bb Tcons bbs) tlistadd aa")
		      (pt "(bb treeadd aa)Tcons(bbs tlistadd aa)"))

(type-to-string (type-of-rec-at (mk-arrow 'tree 'tree 'tree)
				(mk-arrow 'tlist 'tree 'tlist))) 

; =>
; delta_1: (tree=>tree)=>
; delta_2: (tlist=>(tree=>tlist)=>tree=>tree)=>
; delta_3: (tree=>tlist)=>
; delta_4: (tree=>tlist=>(tree=>tree)=>(tree=>tlist)=>tree=>tlist)=>
; tree=>tree=>tree


; 2.  Logic
; =========

(add-ground-type 'arb "x" "y" "z")

(add-pvar-name "P" (make-arity 'arb))
(add-pvar-name "Q" (make-arity))
; (add-pvar-name "R" (make-arity 'arb 'arb))

; (define VERBOSE-SEARCH #t)

; (add-var-name "f" (mk-arrow 'arb 'arb))
; (add-var-name "g" (mk-arrow 'arb 'arb 'arb))


; 2-1.  Propositional logic
; =========================

(define exder1 (pf "(Q1 & Q2 -> Q) -> Q1 -> Q2 -> Q"))
(set-goal exder1)
(assume 1 2 3)
(use-with 1 "?")
(split)
(use 2)
(use 3)
(dcpp)

(define exder2 (pf "(Q1 -> Q2 -> Q) -> Q1 & Q2 -> Q"))
(set-goal exder2)
(assume 1 2)
(use-with 1 "?" "?")
(use-with 2 'left)
(use-with 2 'right)
(dcpp)

(define stab-imp
  (pf "(((Q2 -> F) -> F) -> Q2)
    -> (((Q1 -> Q2) -> F) -> F) -> Q1 -> Q2"))

(set-goal stab-imp)
(search)
(dcpp)

(define peirce (pf "((Q -> F) -> Q) -> Q"))
(set-goal peirce)
(search)

(define stab-to-peirce
  (pf "(((Q1 -> F) -> F) -> Q1)
    -> (((Q2 -> F) -> F) -> Q2)
    -> ((Q1 -> Q2) -> Q1) -> Q1"))
(set-goal stab-to-peirce)
(search)
(dcpp)

(define peirce-and-efq-to-stab
  (pf "(((Q -> F) -> Q) -> Q)
    -> (F -> Q)
    -> ((Q -> F) -> F) -> Q"))
(set-goal peirce-and-efq-to-stab)
(search)
(dcpp)

(define peirce-imp1
  (pf "(((Q2 -> Q) -> Q2) -> Q2)
    -> (((Q1 -> Q2) -> Q) -> Q1 -> Q2) -> Q1 -> Q2"))
(set-goal peirce-imp1)
(search)
(dcpp)

(define peirce-imp2
  (pf "(((Q -> Q2) -> Q) -> Q)
    -> ((Q -> Q1 -> Q2) -> Q) -> Q"))
(set-goal peirce-imp2)
(search)
(dcpp)

(define peirce-and1
  (pf "(((Q1 -> Q) -> Q1) -> Q1)
    -> (((Q2 -> Q) -> Q2) -> Q2)
    -> ((Q1 & Q2 -> Q) -> Q1 & Q2) -> Q1 & Q2"))
(set-goal peirce-and1)
(search)
(dcpp)

(define peirce-and2
  (pf "(((Q -> Q1) -> Q) -> Q)
    -> (((Q -> Q2) -> Q) -> Q)
    -> ((Q -> Q1 & Q2) -> Q) -> Q"))
(set-goal peirce-and2)
(search)
(dcpp)

(define mints (pf "((((Q -> F) -> Q) -> Q) -> F) -> F"))
(set-goal mints)
(search)
(dcpp)

(define kuroda-imp
  (pf "(F -> Q2)
       -> (((Q1 -> F) -> F) -> (Q2 -> F) -> F)
       -> ((Q1 -> Q2) -> F) -> F"))
(set-goal kuroda-imp)
(search)
(dcpp)

; Even a stronger formula (with a hypothesis of a hypothesis
; strengthened) is provable:

(define kuroda-imp1
  (pf "(F -> Q2)
       -> (Q1 -> (Q2 -> F) -> F)
       -> ((Q1 -> Q2) -> F) -> F"))
(set-goal kuroda-imp1)
(search)
(dcpp)

(define mints-c 
  (pf "((((Q1 -> Q2) -> Q1) -> Q1) -> Q3) -> Q3"))
(set-goal mints-c)
(search)
; unprovable by automated search with given multiplicities

(define mints-solovev
  (pf "(Q1 -> (Q -> F) -> Q)
    -> ((Q1 -> Q) -> F)
    -> F"))
(set-goal mints-solovev)
(search)
(dcpp)

(define tatsuta
  (pf "(((Q7 -> Q1) -> Q10) -> Q4 -> Q5)
    -> (((Q8 -> Q2) -> Q9) -> Q3 -> Q10)
    -> (Q1 -> Q8)
    -> Q6
    -> Q7
    -> (((Q3 -> Q2) -> Q9) -> Q4)
    -> (Q1 -> Q3)
    -> (((Q6 -> Q1) -> Q2) -> Q9)
    -> Q5"))
(set-goal tatsuta)
(search)
(dcpp)

(define tatsuta1
  (pf "(((Q8 -> Q2) -> Q9) -> Q3 -> Q10)
    -> (((Q3 -> Q2) -> Q9) -> Q4)
    -> (((Q6 -> Q1) -> Q2) -> Q9)
    -> (((Q7 -> Q1) -> Q10) -> Q4 -> Q5)
    -> (Q1 -> Q3)
    -> (Q1 -> Q8)
    -> Q6
    -> Q7
    -> Q5"))
(set-goal tatsuta1)
(search)
(dcpp)

(define franzen
  (pf "((Q1 -> Q1 & Q2 & Q3) -> F)
    -> ((Q2 -> Q1 & Q2 & Q3) -> F)
    -> ((Q3 -> Q1 & Q2 & Q3) -> F)
    -> F"))
(set-goal franzen)
(search)

; Every negated formula derivable classically is also derivable
; intuitionistically.  For the proof one needs derivations in minimal
; logic of
; ~~~Q -> ~Q (clear) and of
; not-not-stab: (F -> Q) -> ~~(~~Q -> Q)
; not-not-imp:  ~~(Q1 -> Q2) -> ~~Q1 -> ~~Q2

(define not-not-stab
  (pf "(F -> Q) -> ((((Q -> F) -> F) -> Q) -> F) -> F"))
(set-goal not-not-stab)
(search)
(dcpp)

(define not-not-imp
  (pf "(((Q1 -> Q2) -> F) -> F) -> ((Q1 -> F) -> F) -> (Q2 -> F) -> F"))
(set-goal not-not-imp)
(search)
(dcpp)

(define debruijn
  (pf "((Q1 -> Q2) -> (Q2 -> Q1) -> Q1 & Q2 & Q3) 
    -> ((Q2 -> Q3) -> (Q3 -> Q2) -> Q1 & Q2 & Q3) 
    -> ((Q3 -> Q1) -> (Q1 -> Q3) -> Q1 & Q2 & Q3) 
    -> Q1 & Q2 & Q3"))
(set-goal debruijn)
; (search) takes impossibly long time

; Proof in minimal logic:
; Qssume Q1 and Q2.  Then Q3 by (0).  Hence Q1 -> Q2 -> Q3. 
; By symmetry Q1 -> Q3 -> Q2. 
; Hence Q1 -> Q2 by (1)
; By symmetry Q2 -> Q1.
; Hence Q1 & Q2 & Q3 by (0)

(define debruijn-without-and
  (pf "((Q1 -> Q2) -> (Q2 -> Q1) -> Q1)
    -> ((Q1 -> Q2) -> (Q2 -> Q1) -> Q2)
    -> ((Q1 -> Q2) -> (Q2 -> Q1) -> Q3)
    -> ((Q2 -> Q3) -> (Q3 -> Q2) -> Q1)
    -> ((Q2 -> Q3) -> (Q3 -> Q2) -> Q2)
    -> ((Q2 -> Q3) -> (Q3 -> Q2) -> Q3)
    -> ((Q3 -> Q1) -> (Q1 -> Q3) -> Q1)
    -> ((Q3 -> Q1) -> (Q1 -> Q3) -> Q2)
    -> ((Q3 -> Q1) -> (Q1 -> Q3) -> Q3)
    -> Q2"))
(set-goal debruijn-without-and)
; (search) takes impossibly long time


; 2-2.  Quantifier logic
; ======================

(define exder3 (pf "(Q -> all x P x) -> all x.Q -> P x"))
(set-goal exder3)
(assume 1 "x" 2)
(use-with 1 2 (pt "x"))
(dcpp)

(define exder4 (pf "(all x.Q -> P x) -> Q -> all x P x"))
(set-goal exder4)
(assume 1 2 "x")
(use-with 1 (pt "x") 2)
(dcpp)

(define all-imp (pf "(all x.P1 x -> P2 x) -> all x P1 x -> all x P2 x"))
(set-goal all-imp)
(assume 1 2 "x")
(use-with 1 (pt "x") "?")
(use-with 2 (pt "x"))
(dcpp)

(set-goal all-imp)
(search)
(dcpp)

(define all-and1 (pf "(all x.P1 x & P2 x) -> all x P1 x & all x P2 x"))
(set-goal all-and1)
(assume 1)
(split)
(assume "x")
(use-with 1 (pt "x") 'left)
(assume "x")
(use-with 1 (pt "x") 'right)
(dcpp)

(define all-and1 (pf "(all x.P1 x & P2 x) -> all x P1 x & all x P2 x"))
(set-goal all-and1)
(search)
(dcpp)

(define all-and2 (pf " all x P1 x & all x P2 x -> all x.P1 x & P2 x"))
(set-goal all-and2)
(search)
(dcpp)

(define all-excl  (pf "all x P x -> excl x P x"))
(set-goal all-excl)
(search)
(dcpp)

; qf1m is obtained from the formula (all x P x -> Q) -> excl x.P x -> Q
; by (unfolding `excl' into `not all not' and) adding stability of P:

(define qf1m
  (pf "(all x.((P x -> bot) -> bot) -> P x) ->
       (all x P x -> Q) -> excl x.P x -> Q"))
(set-goal qf1m)
(search)
(dcpp)

(define qf2 (pf "(Q -> all y P y) -> all y. Q -> P y"))
(set-goal qf2)
(assume 1 "y" 2)
(use-with 1 2 (pt "y"))
(dcpp)

(define qf2 (pf "(Q -> all y P y) -> all y. Q -> P y"))
(set-goal qf2)
(search)
(dcpp)

; qf3 is obtained from the formula (excl x P x -> Q) -> all x.P x -> Q
; by unfolding `excl' into `not all not':

(define qf3 (pf "(excl x P x -> Q) -> all x.P x -> Q"))
(set-goal qf3)
(search)
(dcpp)

(set-goal qf3)
(assume 1 "x" 2)
(use-with 1 "?")
(assume 3)
(use-with 3 (pt "x") 2)

; qf4m is obtained from the formula (Q -> excl P y) -> excl.Q -> P y
; by unfolding `ex' into `not all not' and adding stability of Q and P:

(define qf4m (pf "(((Q -> bot) -> bot) -> Q)
               -> (all y.((P y -> bot) -> bot) -> P y)
               -> (Q -> excl y P y) -> excl y.Q -> P y"))
(set-goal qf4m)
(search)
(dcpp)

; qf5m is obtained from the formula (excl x.P x -> Q) -> all x P x -> Q
; by unfolding `ex' into `not all not' and adding stability of Q:

(define qf5m (pf "(((Q -> bot) -> bot) -> Q)
               -> ((all x.(P x -> Q) -> bot) -> bot)
               -> all x P x
               -> Q"))
(set-goal qf5m)
(search)
(dcpp)

(define qf6 (pf "(all y. Q -> P y) -> Q -> all y P y"))
(set-goal qf6)
(search)
(dcpp)

; qf7m is obtained from the formula (all x.P x -> Q) -> excl x P x -> Q
; by unfolding `ex' into `not all not' and adding stability of Q:

(define qf7m (pf "(((Q -> bot) -> bot) -> Q)
               -> (all x.P x -> Q) 
               -> ((all x.P x -> bot) -> bot) 
               -> Q"))
(set-goal qf7m)
(search)
(dcpp)

; qf8 is obtained from the formula (excl y.Q -> P y) -> Q -> excl y P y
; by unfolding `excl' into `not all not':

(define qf8 (pf "((all y.(Q -> P y) -> bot) -> bot)
              -> Q 
              -> (all y.P y -> bot)
              -> bot"))
(set-goal qf8)
(search)
(dcpp)

; 3. Partiality
; =============

(add-sfas '("Uzero" nat)
          `("Usucc" ,(mk-arrow 'nat 'nat)))

(define (make-numeric-term n)
  (if (= n 0)
      (pt "Uzero")
      (make-term-in-app-form
       (pt "Usucc")
       (make-numeric-term (- n 1)))))

(av "n" "m" 'nat)

(add-program-constant "+" (mk-arrow 'nat 'nat 'nat) 1 2 'add-op)

(add-computation-rule (pt "n + 0") (pt "n"))
(add-computation-rule (pt "n +  $m") (pt "$(n + m)"))

(add-program-constant "*" (mk-arrow 'nat 'nat 'nat) 1 2 'mul-op)
(add-computation-rule (pt "n * 0") (pt "0"))
(add-computation-rule (pt "n * $m") (pt "(n * m) + n"))

; 3-1.  Predecessor
; =================

(add-program-constant "Pred" (mk-arrow 'nat 'nat) 0 1 'prefix-op)
(add-computation-rule (pt "Pred($n)") (pt "n"))

(dt (nt (pt "Pred ($ $ 0)")))
(dt (nt (pt "Pred($n)")))

; Existence predicate
(dt (pt "(Eat nat)"))
(dt (nt (pt "(Eat nat) Uzero")))
(dt (nt (pt "E 0"))) ;shorter E is a prefix operator for (Eat ...)
(dt (nt (pt "E 2")))
(dt (nt (pt "E n")))
(dt (nt (pt "E n^")))
(dt (nt (pt "E $ $ n")))
(dt (nt (pt "E $ $ n^")))

(dt (nt (pt "E Pred n"))) ;=> (Eat nat)(Pred n)
(dt (nt (pt "E Pred $ n"))) ;=> True
(dt (nt (pt "E Pred $ n^"))) ;=> (Eat nat) n^

(set-goal (pf "all m.all n 1 + n = n + 1 -> 1 + Pred m = (Pred m) + 1"))
(assume "m" 1)
; (use-with 1 (pt "Pred m")) ;=> error: (Pred m) is not total

(set-goal (pf "all m.all n 1 + n = n + 1 -> 1 + $ m = ($ m) + 1"))
(assume "m" 1)
(use-with 1 (pt "$ m"))

; 3-2.  Fixed Points
; ==================

(define one-type (mk-arrow 'nat 'nat))

(add-program-constant "Fix" (mk-arrow (mk-arrow one-type one-type) one-type))

(add-var-name "G" (mk-arrow one-type one-type))

(add-computation-rule (pt "Fix G n") (pt "G(Fix G)n"))

; (dt (nt (pt "Fix G"))) ;does not terminate: (Fix G) on the rhs is expanded

; Try: will it terminate for a trivial G0?

(add-program-constant "Gtrivial" (mk-arrow one-type one-type))
(add-var-name "f" one-type)
(add-computation-rule (pt "Gtrivial f n") (pt "0"))

(dt (nt (pt "Fix Gtrivial 7"))) ;-> Uzero: (Fix G) on the rhs 
; is not expanded, because G.. terminates without having to look
; into its arguments

; (dt (nt (pt "Fix G 7"))) ;does not terminate

(add-program-constant "Gfac" (mk-arrow one-type one-type))
(add-computation-rule (pt "Gfac f n")
		      (pt "[if (n=0) 1 (n * f(Pred n))]"))

(dt (nt (pt "Fix Gfac 0"))) ;=> 1
(dt (nt (pt "Fix Gfac 1"))) ;=> Usucc Uzero
(dt (nt (pt "Fix Gfac 2"))) ;=> Usucc(Usucc Uzero)
(dt (nt (pt "Fix Gfac 3"))) ;=> Usucc(Usucc(Usucc(Usucc(Usucc(Usucc Uzero)))))

; (dt (nt (pt "Fix Gfac n"))) ;does not terminate: reprod. looks at all args
; (dt (nt (pt "Fix Gfac ($ n)"))) ;does not terminate: calls Fix Gfac n

; Note: (dt (nt (pt "Fix Gfac 0"))) would not terminate, if Gfac is
; defined with recursion (pt "(RECat boole=>nat) 1 (n * f(Pred n)) (n=0)") 
; instead of the if-construct; it then looks into its function argument.

; Question: do we have Fix Gfac n -> Q for some term Q?  Answer: no, by
; the same argument as for the counterexample before Lemma 4.  Note that
; Fix Gfac n is not normalizable.

; 3-3.  Minimum operator
; ======================

(add-program-constant "mu" (mk-arrow one-type one-type))
(add-computation-rule (pt "mu f n") (pt "[if (0=f n) n (mu f($ n))]"))

(add-program-constant "ftest" one-type)
(add-rewrite-rule (pt "ftest 0") (pt "1"))
(add-rewrite-rule (pt "ftest 1") (pt "2"))
(add-rewrite-rule (pt "ftest 2") (pt "0"))

(dt (nt (pt "mu ftest 0"))) ;=> Usucc(Usucc Uzero)
; (dt (nt (pt "mu ftest n"))) ;does not terminate


