; This file is automaticaly generated. Do not edit!

; *** Literal Code ***


(define (token-type-to-arity token)
  (case token
    ((postfix-typeop prefix-typeop postfix-op prefix-op postfix-jct prefix-jct)
     1)
    ((prod-typeop tensor-typeop sum-typeop binding-op add-op mul-op
      rel-op and-op or-op imp-op pair-op and-jct or-jct tensor-jct imp-jct)
     2)
    (else 0)))

(define (alg-name-to-token-value alg-name)
  (let ((token-type (alg-name-to-token-type alg-name)))
    (case (token-type-to-arity token-type)
      ((0) alg-name)
      ((1) (lambda (x) (make-alg alg-name x)))
      ((2) (lambda (x y) (make-alg alg-name x y)))
      (else (myerror "unexpected arity" token-type)))))

(define (const-to-token-value const)
  (let ((token-type (const-to-token-type const)))
    (case (token-type-to-arity token-type)
      ((0) (make-term-in-const-form const))
      ((1) (lambda (x) 
	     (make-term-in-app-form 
	      (make-term-in-const-form const) x)))
      ((2) (lambda (x y) 
	     (make-term-in-app-form 
	      (make-term-in-app-form 
	       (make-term-in-const-form const) x) y)))
      (else (myerror "unexpected arity" token-type)))))

; added 01-07-14
(define (const-and-token-type-to-token-value const token-type)
  (case (token-type-to-arity token-type)
    ((0) (make-term-in-const-form const))
    ((1) (lambda (x) 
	   (make-term-in-app-form 
	    (make-term-in-const-form const) x)))
    ((2) (lambda (x y) 
	   (make-term-in-app-form 
	    (make-term-in-app-form 
	     (make-term-in-const-form const) x) y)))
    (else (myerror "unexpected arity" token-type))))

(define (token-type-to-precedence token-type)
  (case token-type
    ((binding-op bindterm) 1)
    ((pair-op term) 2)
    ((imp-op impterm) 3)
    ((or-op orterm) 4)
    ((and-op andterm) 5)
    ((rel-op relterm) 6)
    ((add-op addterm) 7)
    ((mul-op multerm) 8)
    ((appterm) 9)
    ((prefix-op preterm) 10)
    ((postfix-op postterm) 11)
    ((const var number rec-op if-op atomic-term) 12)
    (else (myerror
	   "token-type-to-precendence: token type expected" token-type))))

(define (left-assoc? token-type)
  (memq token-type
	'(add-op addterm mul-op multerm and-op andterm or-op orterm appterm)))
			    
(define (right-assoc? token-type)
  (memq token-type '(pair-op term imp-op impterm)))

(define (type-var-name-to-type type-var-name)
  (if (eq? (car type-var-name) #f)
      (myerror "Unknown variable name " (cdr type-var-name))
      (car type-var-name)))

(define (type-var-name-to-name type-var-name)
  (cdr type-var-name))

(define (pt string)
  (let ((t (pf string)))
    (if (eq? (car t) 'atom)
	(cadr t)
	(myerror "pt: term expected" t))))

(define (py string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(cadr t)
	(myerror "py: type expected" t))))

(define (pv string)
  (let ((t (pt string)))
    (if (eq? (car t) 'term-in-var-form)
	(term-in-var-form-to-var t)
	(myerror "pv: variable expected" t))))

; *** Token Definitions ***
(define token-nrs
  (list 
   (cons '*eoi* 0)
   (cons 'number 1)
   (cons 'var-index 2)
   (cons 'tvar-name 3)
   (cons 'tconst 4)
   (cons 'var-name 5)
   (cons 'const 6)
   (cons 'pvar-name 7)
   (cons 'pvar-op 8)
   (cons 'pred-infix 9)
   (cons 'predconst-name 10)
   (cons 'idpredconst-name 11)
   (cons 'idpredconstscheme-name 12)
   (cons 'idpredconstscheme-name-wit 13)
   (cons 'type-symbol 14)
   (cons 'alg 15)
   (cons 'constscheme 16)
   (cons 'alg-typeop 17)
   (cons 'postfix-typeop 18)
   (cons 'prefix-typeop 19)
   (cons 'prod-typeop 20)
   (cons 'tensor-typeop 21)
   (cons 'sum-typeop 22)
   (cons 'arrow 23)
   (cons 'postfix-op 24)
   (cons 'prefix-op 25)
   (cons 'rec-op 26)
   (cons 'binding-op 27)
   (cons 'add-op 28)
   (cons 'mul-op 29)
   (cons 'rel-op 30)
   (cons 'and-op 31)
   (cons 'or-op 32)
   (cons 'imp-op 33)
   (cons 'pair-op 34)
   (cons 'pairscheme-op 35)
   (cons 'cterm-op 36)
   (cons 'if-op 37)
   (cons 'postfix-jct 38)
   (cons 'prefix-jct 39)
   (cons 'and-jct 40)
   (cons 'or-jct 41)
   (cons 'tensor-jct 42)
   (cons 'imp-jct 43)
   (cons 'quantor 44)
   (cons 'dot 45)
   (cons 'hat 46)
   (cons 'underscore 47)
   (cons 'comma 48)
   (cons 'semicolon 49)
   (cons 'prime 50)
   (cons 'hatprime 51)
   (cons 'hatprimeunderscore 52)
   (cons 'hatunderscore 53)
   (cons 'primeunderscore 54)
   (cons 'lpar 55)
   (cons 'rpar 56)
   (cons 'lbracket 57)
   (cons 'rbracket 58)
   (cons 'lcurl 59)
   (cons 'rcurl 60)
   (cons 'undefined-token 61)
   (cons 'string 62)
   (cons 'mpc-mpc 63)
   (cons 'mpc-proof 64)
   (cons 'mpc-classic 65)
   (cons 'mpc-intuitionistic 66)
   (cons 'mpc-end 67)
   (cons 'mpc-load 68)
   (cons 'mpc-include 69)
   (cons 'mpc-scheme 70)
   (cons 'mpc-type 71)
   (cons 'mpc-pred 72)
   (cons 'mpc-algebra 73)
   (cons 'mpc-function 74)
   (cons 'mpc-partial 75)
   (cons 'mpc-rewrite 76)
   (cons 'mpc-syntax 77)
   (cons 'mpc-op 78)
  ))

(define token-defs
  (vector 
 "*eoi*"
 "number"
 "var-index"
 "tvar-name"
 "tconst"
 "var-name"
 "const"
 "pvar-name"
 "pvar-op"
 "pred-infix"
 "predconst-name"
 "idpredconst-name"
 "idpredconstscheme-name"
 "idpredconstscheme-name-wit"
 "type-symbol"
 "alg"
 "constscheme"
 "alg-typeop"
 "postfix-typeop"
 "prefix-typeop"
 "prod-typeop"
 "tensor-typeop"
 "sum-typeop"
 "arrow"
 "postfix-op"
 "prefix-op"
 "rec-op"
 "binding-op"
 "add-op"
 "mul-op"
 "rel-op"
 "and-op"
 "or-op"
 "imp-op"
 "pair-op"
 "pairscheme-op"
 "cterm-op"
 "if-op"
 "postfix-jct"
 "prefix-jct"
 "and-jct"
 "or-jct"
 "tensor-jct"
 "imp-jct"
 "quantor"
 "dot"
 "hat"
 "underscore"
 "comma"
 "semicolon"
 "prime"
 "hatprime"
 "hatprimeunderscore"
 "hatunderscore"
 "primeunderscore"
 "lpar"
 "rpar"
 "lbracket"
 "rbracket"
 "lcurl"
 "rcurl"
 "undefined-token"
 "string"
 "mpc-mpc"
 "mpc-proof"
 "mpc-classic"
 "mpc-intuitionistic"
 "mpc-end"
 "mpc-load"
 "mpc-include"
 "mpc-scheme"
 "mpc-type"
 "mpc-pred"
 "mpc-algebra"
 "mpc-function"
 "mpc-partial"
 "mpc-rewrite"
 "mpc-syntax"
 "mpc-op"
  ))

; *** Action Table ***
(define action-table
  '#(
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2) (63 . 1))
     ((default . *error*) (49 . 61))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (37 . 63) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 70) (10 . 12) (11 . 11) (12 . 69) (13 . 68) (15 . 10) (16 . 67) (17 . 9) (19 . 8) (25 . 7) (26 . 66) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (55 . 79) (57 . 78))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (55 . 62))
     ((default . -122))
     ((default . -34))
     ((default . -34) (2 . 85) (47 . 84))
     ((default . -82))
     ((default . -44) (2 . 94) (46 . 93) (47 . 92) (50 . 91) (51 . 90) (52 . 89) (53 . 88) (54 . 87))
     ((default . -154))
     ((default . -86) (2 . 97) (46 . 96) (47 . 95))
     ((default . -121))
     ((default . -126) (2 . 98))
     ((default . -156))
     ((default . -3))
     ((default . -152))
     ((default . -150) (24 . 99))
     ((default . -148))
     ((default . -146))
     ((default . -144) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . -142) (29 . 102))
     ((default . -140) (28 . 104) (30 . 103))
     ((default . -138))
     ((default . -136) (31 . 105))
     ((default . -134) (32 . 107) (33 . 106))
     ((default . -132) (34 . 109) (35 . 108))
     ((default . -32) (9 . 111))
     ((default . -120))
     ((default . -119))
     ((default . -117) (18 . 112))
     ((default . -113))
     ((default . -112) (3 . 18) (4 . 17) (15 . 10) (55 . 62))
     ((default . -109) (20 . 114))
     ((default . -107) (21 . 115))
     ((default . -105) (22 . 117) (23 . 116))
     ((default . -92) (2 . 120) (46 . 119) (47 . 118))
     ((default . -155))
     ((default . -60) (2 . 128) (46 . 127) (47 . 126) (50 . 125) (51 . 124) (52 . 123) (53 . 122) (54 . 121))
     ((default . -34))
     ((default . -34))
     ((default . -31))
     ((default . -30))
     ((default . -27))
     ((default . -25) (38 . 131))
     ((default . -17))
     ((default . -19))
     ((default . -15))
     ((default . -13) (40 . 132))
     ((default . -11))
     ((default . -9) (41 . 134) (42 . 133))
     ((default . -6))
     ((default . -7) (43 . 135))
     ((default . -4))
     ((default . -2))
     ((default . *error*) (0 . 136))
     ((default . -165))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -85) (48 . 141))
     ((default . *error*) (58 . 142))
     ((default . *error*) (1 . 143) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 147))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -82) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -32) (9 . 111) (56 . 153))
     ((default . -92) (2 . 120) (46 . 119) (47 . 118) (56 . 154))
     ((default . *error*) (56 . 155))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (45 . 156) (55 . 3) (57 . 2))
     ((default . -24))
     ((default . -22))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (45 . 159) (55 . 79) (57 . 78))
     ((default . *error*) (37 . 63))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (16 . 67) (17 . 9) (19 . 8) (25 . 7) (26 . 66) (27 . 6) (55 . 79) (57 . 2))
     ((default . -149))
     ((default . -116))
     ((default . -115))
     ((default . -40) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -34) (2 . 163))
     ((default . -34))
     ((default . -36) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -55) (2 . 166))
     ((default . -56) (2 . 167))
     ((default . -59) (2 . 168))
     ((default . -53) (2 . 169))
     ((default . -50) (2 . 170))
     ((default . -49) (2 . 171))
     ((default . -47) (2 . 172))
     ((default . -45))
     ((default . -91) (2 . 173))
     ((default . -89) (2 . 174))
     ((default . -87))
     ((default . -127))
     ((default . -151))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -145))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . -118))
     ((default . -114))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -97) (2 . 192) (5 . 191))
     ((default . -95) (2 . 193))
     ((default . -93))
     ((default . -71) (2 . 194))
     ((default . -72) (2 . 195))
     ((default . -75) (2 . 196))
     ((default . -68) (2 . 197))
     ((default . -66) (2 . 198))
     ((default . -65) (2 . 199))
     ((default . -63) (2 . 200))
     ((default . -61))
     ((default . -28) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -41) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -26))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . -1) (0 . accept))
     ((default . -164) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2) (59 . 221) (64 . 220) (65 . 219) (66 . 218) (67 . 217) (68 . 216) (69 . 215) (70 . 214) (71 . 213) (72 . 212) (73 . 211) (74 . 210) (75 . 209) (77 . 208) (49 . -180))
     ((default . *error*) (56 . 154))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78) (58 . 233))
     ((default . -161))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 238))
     ((default . -124))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 240))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (36 . 241) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 147))
     ((default . *error*) (55 . 244) (56 . 243))
     ((default . -80))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 147) (56 . 246))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 248))
     ((default . -153))
     ((default . -123))
     ((default . -33))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . -23))
     ((default . -21))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . -147))
     ((default . *error*) (56 . 153))
     ((default . -35))
     ((default . -34))
     ((default . -39) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -37) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -54))
     ((default . -57))
     ((default . -58))
     ((default . -52))
     ((default . -51))
     ((default . -48))
     ((default . -46))
     ((default . -90))
     ((default . -88))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (55 . 79) (57 . 78))
     ((default . -143) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 100) (55 . 79) (57 . 78))
     ((default . -139) (28 . 104))
     ((default . -141) (29 . 102))
     ((default . -137))
     ((default . -133))
     ((default . -135) (31 . 105))
     ((default . -163) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -128))
     ((default . -129))
     ((default . -29))
     ((default . -111))
     ((default . -110) (3 . 18) (4 . 17) (15 . 10) (55 . 62))
     ((default . -108) (20 . 114))
     ((default . -104))
     ((default . -106) (21 . 115))
     ((default . -98) (2 . 254) (46 . 253) (47 . 252))
     ((default . -96))
     ((default . -94))
     ((default . -70))
     ((default . -73))
     ((default . -74))
     ((default . -69))
     ((default . -67))
     ((default . -64))
     ((default . -62))
     ((default . -16))
     ((default . -18))
     ((default . -10))
     ((default . -8))
     ((default . -14))
     ((default . -12) (40 . 132))
     ((default . -5))
     ((default . *error*) (24 . 264) (25 . 263) (28 . 262) (29 . 261) (30 . 260) (31 . 259) (32 . 258) (33 . 257) (34 . 256) (61 . 255))
     ((default . *error*) (74 . 266))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (61 . 268))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (45 . 270) (55 . 62))
     ((default . *error*) (45 . 272))
     ((default . *error*) (62 . 273))
     ((default . *error*) (62 . 274))
     ((default . *error*) (62 . 275))
     ((default . -179))
     ((default . *error*) (64 . 276))
     ((default . *error*) (64 . 277))
     ((default . -176))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (49 . 280))
     ((default . -195) (59 . 281))
     ((default . *error*) (59 . 283))
     ((default . *error*) (49 . 284))
     ((default . -170))
     ((default . *error*) (45 . 285))
     ((default . *error*) (49 . 286))
     ((default . *error*) (49 . 287))
     ((default . -166))
     ((default . -92) (2 . 120) (46 . 119) (47 . 118) (45 . 288))
     ((default . -181) (45 . -182))
     ((default . -160))
     ((default . -162))
     ((default . -84))
     ((default . -131))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 289))
     ((default . -157))
     ((default . -125))
     ((default . -159))
     ((default . *error*) (55 . 290))
     ((default . *error*) (55 . 244) (56 . 291))
     ((default . -42))
     ((default . *error*) (36 . 241))
     ((default . -81))
     ((default . -77))
     ((default . *error*) (55 . 244) (56 . 292))
     ((default . -83))
     ((default . -20))
     ((default . -130))
     ((default . -38) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (55 . 79) (57 . 78))
     ((default . -103) (2 . 293))
     ((default . -101) (2 . 294))
     ((default . -99))
     ((default . -213))
     ((default . -214))
     ((default . -215))
     ((default . -216))
     ((default . -217))
     ((default . -218))
     ((default . -220))
     ((default . -219))
     ((default . -221))
     ((default . -222))
     ((default . *error*) (78 . 295))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (45 . 297))
     ((default . -200) (61 . 268))
     ((default . -199) (1 . 299))
     ((default . *error*) (61 . 268))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (45 . 301) (55 . 62))
     ((default . *error*) (61 . 268))
     ((default . -175))
     ((default . -174))
     ((default . -173))
     ((default . -178))
     ((default . -177))
     ((default . -180) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2) (59 . 221))
     ((default . *error*) (45 . 307))
     ((default . -172))
     ((default . -196))
     ((default . -207))
     ((default . -202) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -171))
     ((default . -168))
     ((default . -169))
     ((default . -167))
     ((default . *error*) (61 . 268))
     ((default . -158))
     ((default . *error*) (3 . 18) (4 . 17) (5 . 16) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 313))
     ((default . -43))
     ((default . -76))
     ((default . -102))
     ((default . -100))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (45 . 316))
     ((default . *error*) (61 . 317))
     ((default . -201))
     ((default . -198))
     ((default . -192))
     ((default . *error*) (61 . 268))
     ((default . -189))
     ((default . -180) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2) (59 . 221) (60 . 319))
     ((default . -186))
     ((default . *error*) (49 . 322))
     ((default . -181))
     ((default . -184))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2) (60 . 324) (76 . 323) (77 . 208))
     ((default . -202) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (60 . 330))
     ((default . *error*) (45 . 331))
     ((default . -190))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (56 . 333))
     ((default . -212))
     ((default . *error*) (61 . 334))
     ((default . *error*) (55 . 335))
     ((default . -191))
     ((default . -183))
     ((default . -187))
     ((default . *error*) (49 . 336))
     ((default . -185))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . -197))
     ((default . *error*) (49 . 338))
     ((default . -208))
     ((default . -194))
     ((default . *error*) (43 . 339))
     ((default . -203))
     ((default . -193))
     ((default . *error*) (61 . 340))
     ((default . *error*) (56 . 341))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (7 . 14) (8 . 13) (10 . 12) (11 . 11) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (39 . 5) (44 . 4) (55 . 3) (57 . 2))
     ((default . *error*) (55 . 343))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . -188))
     ((default . *error*) (43 . 345))
     ((default . -209))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (49 . 347))
     ((default . -79))
     ((default . *error*) (56 . 348))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 350))
     ((default . *error*) (1 . 19) (3 . 18) (4 . 17) (5 . 16) (6 . 15) (15 . 10) (17 . 9) (19 . 8) (25 . 7) (27 . 6) (55 . 79) (57 . 2))
     ((default . *error*) (49 . 352))
     ((default . -204))
     ((default . -78))
     ((default . *error*) (3 . 18) (4 . 17) (15 . 10) (17 . 9) (19 . 8) (55 . 62) (56 . 353))
     ((default . -205))
     ((default . *error*) (49 . 354))
     ((default . -210))
     ((default . -206))
     ((default . -211))
    ))

; *** Goto Table ***
(define goto-table
  '#(
     ((48 . 20)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 59)(1 . 60))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 65))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 71)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 72)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 73))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 74))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 75)(10 . 76))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 77))
     ((45 . 21)(44 . 22)(43 . 80)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 81))
     ((33 . 33)(31 . 82))
     ()
     ((14 . 83))
     ((14 . 86))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 101)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ((47 . 110))
     ()
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 113))
     ()
     ()
     ()
     ()
     ()
     ()
     ((14 . 129))
     ((14 . 130))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((49 . 137))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 138))
     ((46 . 139)(45 . 140)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ((33 . 33)(32 . 144)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((33 . 33)(32 . 146)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((33 . 33)(32 . 148)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145)(20 . 149)(19 . 150))
     ((33 . 33)(32 . 151)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((33 . 33)(32 . 152)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 157)(10 . 158))
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 160)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 161)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 72)(23 . 42))
     ()
     ()
     ()
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((14 . 164))
     ((14 . 165))
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 175))
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 176)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 177)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 178)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 179)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 180)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 181)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((33 . 33)(32 . 182)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 183)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 184)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 185)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 186)(28 . 187))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 188))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 189))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 190))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 201)(10 . 202))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 203)(4 . 204))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 205)(8 . 206))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 207))
     ()
     ((67 . 222)(64 . 223)(60 . 224)(57 . 225)(54 . 226)(53 . 227)(52 . 228)(51 . 229)(50 . 230)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 231)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 232))
     ()
     ((45 . 234)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 235))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 236)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((33 . 33)(32 . 237)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 138))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239)(20 . 242)(19 . 150))
     ((19 . 245))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239)(20 . 247)(19 . 150))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 249))
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 250)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ((14 . 251))
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 160)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 101)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 113))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((68 . 265))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 267))
     ((61 . 269))
     ((33 . 33)(32 . 271)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((55 . 278)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 279))
     ()
     ((58 . 282))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ()
     ()
     ()
     ()
     ((19 . 245))
     ()
     ()
     ()
     ()
     ((19 . 245))
     ()
     ()
     ()
     ((45 . 162)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 296))
     ()
     ((61 . 298))
     ()
     ((61 . 300))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ((61 . 302))
     ()
     ()
     ()
     ()
     ()
     ((56 . 303)(54 . 304)(52 . 305)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 306))
     ()
     ()
     ()
     ((65 . 308))
     ((63 . 309)(62 . 310)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 311))
     ()
     ()
     ()
     ()
     ((61 . 312))
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 64)(22 . 314))
     ()
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 315)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ((61 . 318))
     ()
     ((54 . 320)(52 . 321)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 306))
     ()
     ()
     ()
     ()
     ((67 . 325)(66 . 326)(59 . 327)(45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 328)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ((63 . 309)(62 . 329)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 311))
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 332))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 337)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 32)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42)(21 . 43)(18 . 44)(17 . 45)(16 . 46)(15 . 47)(13 . 48)(12 . 49)(11 . 50)(10 . 51)(9 . 52)(8 . 53)(7 . 54)(6 . 55)(5 . 56)(4 . 57)(3 . 58)(2 . 342))
     ()
     ((33 . 33)(32 . 344)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ()
     ()
     ()
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 346)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ((33 . 33)(32 . 349)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 145))
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ((45 . 21)(44 . 22)(43 . 23)(42 . 24)(41 . 25)(40 . 26)(39 . 27)(38 . 28)(37 . 29)(36 . 30)(35 . 31)(34 . 351)(33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 41)(23 . 42))
     ()
     ()
     ()
     ((33 . 33)(31 . 34)(30 . 35)(29 . 36)(28 . 37)(27 . 38)(26 . 39)(25 . 40)(24 . 239))
     ()
     ()
     ()
     ()
     ()
    ))

; *** Reduction Table ***
(define reduction-table
  (vector
    '()
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (accept $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 1 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 2 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 3 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 3 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 4 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 4 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 5 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 5 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 6 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 6 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 7 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 7 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 8 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 8 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 9 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 9 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 10 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 10 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 10 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 11 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 11 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 11 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 12 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 12 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 13 goto-table (apply make-predicate-formula (cons $1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 13 goto-table (make-atomic-formula $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 13 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 14 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 14 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 15 goto-table (apply $1 (cons -1 $2)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons $2 $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 15 goto-table (apply $1 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 15 goto-table (apply $1 (cons -1 $3)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 16 goto-table (apply $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 17 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 17 goto-table ($2 $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar (car $1) -1 (quote no-positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) $2 (quote no-positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote no-positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote no-positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote no-positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote no-positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote no-positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote no-positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote positive-content) (quote no-negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar (car $1) $3 (quote positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar (car $1) -1 (quote positive-content) (quote negative-content) (cdr $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 18 goto-table (make-pvar $1 -1 (quote no-positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 $2 (quote no-positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote no-positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote no-positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote no-positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote no-positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote no-positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote no-positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote positive-content) (quote no-negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 18 goto-table (make-pvar $1 $3 (quote positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 18 goto-table (make-pvar $1 -1 (quote positive-content) (quote negative-content) ""))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 18 goto-table (idpredconst-name-and-types-and-cterms-to-idpredconst $2 $3 (quote ())))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 19 goto-table (apply make-cterm (append $4 (list $6))))))
    (lambda (stack sp goto-table)
      (let* (($6 (vector-ref stack (- sp 1)))
             ($5 (vector-ref stack (- sp 3)))
             ($4 (vector-ref stack (- sp 5)))
             ($3 (vector-ref stack (- sp 7)))
             ($2 (vector-ref stack (- sp 9)))
             ($1 (vector-ref stack (- sp 11))))
          (push stack (- sp 12) 19 goto-table (make-cterm $5))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 20 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 20 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 21 goto-table (make-arity))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 21 goto-table (apply make-arity $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 22 goto-table (cons $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 22 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) $2 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 0 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var (type-var-name-to-type $1) $3 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var (type-var-name-to-type $1) -1 1 (type-var-name-to-name $1)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 $2 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 0 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 $3 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 23 goto-table (make-var $1 -1 1 ""))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 $4 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 0 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 23 goto-table (make-var $1 $5 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 23 goto-table (make-var $1 -1 1 (type-var-name-to-name $3)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 24 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 24 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 25 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 25 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 26 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 26 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 27 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 27 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (apply make-alg (cons (alg-form-to-name $1) (append (alg-form-to-types $1) (list $2)))))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 28 goto-table (make-alg $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 29 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 29 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 30 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 30 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-tconst $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 31 goto-table (make-alg $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 31 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 32 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 32 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 33 goto-table (make-tvar -1 $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 33 goto-table (make-tvar $2 $1))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 34 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table ($1 $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 34 goto-table (apply mk-term-in-abst-form (append $2 (list $4))))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 34 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 35 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 35 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 36 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 36 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 37 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 37 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 38 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 38 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 39 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 39 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 40 goto-table ($2 $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 40 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 41 goto-table (make-gen-application $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 41 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 42 goto-table ($1 $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 42 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 43 goto-table ($1 $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 43 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 44 goto-table ($2 $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 44 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 45 goto-table $2)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table (make-term-in-var-form $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 45 goto-table (make-numeric-term $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 45 goto-table ($2 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 45 goto-table ($2 (cons $3 $4)))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 45 goto-table (make-term-in-const-form (let* ((tvars (const-to-tvars $2)) (subst (make-substitution tvars $3))) (const-substitute $2 subst #f))))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 45 goto-table (make-term-in-if-form (car $3) (cdr $3)))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 46 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 46 goto-table (append $1 (list $2)))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 47 goto-table (lambda (x y) (make-term-in-app-form (make-term-in-app-form (make-term-in-const-form (let* ((tvars (const-to-tvars $1)) (subst (make-substitution tvars $2))) (const-substitute $1 subst #f))) x) y)))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 48 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 49 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 49 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 50 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table (mpc-command-load $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table (mpc-command-include $2))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table (mpc-command-scheme $2))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 51 goto-table (mpc-start #f #f))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table (mpc-start #t #t))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 51 goto-table (mpc-start #t #f))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 51 goto-table (mpc-stop))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 52 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 52 goto-table (mpc-claim $1))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 53 goto-table (mpc-assume $1))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 54 goto-table (mpc-block-stop))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 55 goto-table (mpc-block-start $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 56 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 56 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 56 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 56 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table (mpc-declare-type $3))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table (mpc-declare-var $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 57 goto-table (mpc-declare-pred (apply make-arity $2) $4))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 57 goto-table (mpc-declare-pred (make-arity) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 57 goto-table (mpc-declare-algebra (car $1) (cadr $1) (cddr $1) $3))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 57 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 57 goto-table (mpc-function))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 58 goto-table (mpc-function-rules-start))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 59 goto-table (mpc-function-rules-stop))))
    (lambda (stack sp goto-table)
      (let* (($3 (vector-ref stack (- sp 1)))
             ($2 (vector-ref stack (- sp 3)))
             ($1 (vector-ref stack (- sp 5))))
          (push stack (- sp 6) 60 goto-table (mpc-declare-algebra-header $2 $3))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 60 goto-table (mpc-declare-algebra-header $2 0))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 61 goto-table (list $1))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 61 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 62 goto-table (quote ()))))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 62 goto-table (cons $1 $2))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 63 goto-table (list $3 $1))))
    (lambda (stack sp goto-table)
      (let* (($7 (vector-ref stack (- sp 1)))
             ($6 (vector-ref stack (- sp 3)))
             ($5 (vector-ref stack (- sp 5)))
             ($4 (vector-ref stack (- sp 7)))
             ($3 (vector-ref stack (- sp 9)))
             ($2 (vector-ref stack (- sp 11)))
             ($1 (vector-ref stack (- sp 13))))
          (push stack (- sp 14) 64 goto-table (mpc-declare-function $4 $6 $2 1))))
    (lambda (stack sp goto-table)
      (let* (($8 (vector-ref stack (- sp 1)))
             ($7 (vector-ref stack (- sp 3)))
             ($6 (vector-ref stack (- sp 5)))
             ($5 (vector-ref stack (- sp 7)))
             ($4 (vector-ref stack (- sp 9)))
             ($3 (vector-ref stack (- sp 11)))
             ($2 (vector-ref stack (- sp 13)))
             ($1 (vector-ref stack (- sp 15))))
          (push stack (- sp 16) 64 goto-table (mpc-declare-function $5 $7 $3 0))))
    (lambda (stack sp goto-table)
      (let* ()
          (push stack (- sp 0) 65 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 65 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($2 (vector-ref stack (- sp 1)))
             ($1 (vector-ref stack (- sp 3))))
          (push stack (- sp 4) 66 goto-table #t)))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 66 goto-table (mpc-computation-rule $1 $3))))
    (lambda (stack sp goto-table)
      (let* (($5 (vector-ref stack (- sp 1)))
             ($4 (vector-ref stack (- sp 3)))
             ($3 (vector-ref stack (- sp 5)))
             ($2 (vector-ref stack (- sp 7)))
             ($1 (vector-ref stack (- sp 9))))
          (push stack (- sp 10) 66 goto-table (mpc-rewrite-rule $2 $4))))
    (lambda (stack sp goto-table)
      (let* (($4 (vector-ref stack (- sp 1)))
             ($3 (vector-ref stack (- sp 3)))
             ($2 (vector-ref stack (- sp 5)))
             ($1 (vector-ref stack (- sp 7))))
          (push stack (- sp 8) 67 goto-table (mpc-declare-syntax $2 (car $3) (cadr $3) (caddr $3) $4))))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table $1)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
    (lambda (stack sp goto-table)
      (let* (($1 (vector-ref stack (- sp 1))))
          (push stack (- sp 2) 68 goto-table current-token)))
  ))

; *** Parser Definition ***
(define parser
   (make-parser
    action-table
    goto-table
    reduction-table
    token-defs))

; *** Terminals Table ***

(define terminal-table
   `#(
   ()
   ()
   (("excl" 44 . ,(lambda (v k) (apply mk-excl (append v (list k))))))
   (("CONST" 78 . ,(list (quote const) "CONST" 0)))
   (("LOAD" 68)("=>" 23 . ,make-arrow))
   ()
   (("cterm" 36))
   (("SYNTAX" 77))
   ()
   ()
   (("lambda" 27 . ,(lambda (varlist kernel) (apply mk-term-in-abst-form (append varlist (list kernel))))))
   ()
   ()
   ()
   ()
   (("IMPOP" 78 . ,(list (quote imp-op) "IMPOP" 2)))
   ()
   ()
   (("END" 67)("^'" 51))
   ()
   ()
   ()
   ()
   ()
   (("ADDOP" 78 . ,(list (quote add-op) "ADDOP" 2)))
   ()
   (("{" 59))
   (("^'_" 52)("@@" 20 . ,make-star))
   (("}" 60))
   (("OROP" 78 . ,(list (quote or-op) "OROP" 2)))
   ()
   ()
   ()
   (("!" 42 . ,make-tensor))
   ()
   (("MPC" 63))
   ()
   (("CLASSIC" 65))
   (("SCHEME" 70)("&" 40 . ,make-and))
   (("'" 50))
   (("(" 55)("allnc" 44 . ,(lambda (v k) (apply mk-allnc (append v (list k))))))
   ((")" 56))
   (("MULOP" 78 . ,(list (quote mul-op) "MULOP" 2))("REWRITE" 76)("Total" 10 . ,(string-and-arity-to-predconst-parse-function "Total" (make-arity (make-tvar -1 "alpha")))))
   (("PAIROP" 78 . ,(list (quote pair-op) "PAIROP" 2)))
   (("," 48))
   (("atomic" 4 . ,"atomic"))
   (("TYPE" 71)("." 45)("left" 25 . ,make-term-in-lcomp-form))
   ()
   (("PROOF" 64))
   ()
   (("INTUITIONISTIC" 66))
   (("ex" 44 . ,(lambda (v k) (apply mk-ex (append v (list k))))))
   ()
   ()
   ()
   ()
   ()
   ()
   (("INCLUDE" 69))
   (("ANDOP" 78 . ,(list (quote and-op) "ANDOP" 2))("FUNCTION" 74)(";" 49))
   (("RELOP" 78 . ,(list (quote rel-op) "RELOP" 2))("PARTIAL" 75))
   (("if" 37)("=" 30 . ,(lambda (term1 term2) (let ((type1 (term-to-type term1)) (type2 (term-to-type term2))) (mk-term-in-app-form (make-term-in-const-form (finalg-to-=-const (if (equal? type1 type2) type1 (types-lub type1 type2)))) term1 term2)))))
   ()
   ()
   (("@" 34 . ,make-term-in-pair-form))
   (("Pvar" 8))
   (("POSTFIXOP" 78 . ,(list (quote postfix-op) "POSTFIXOP" 1))("ALGEBRA" 73)("existential" 4 . ,"existential")("STotal" 10 . ,(string-and-arity-to-predconst-parse-function "STotal" (make-arity (make-tvar -1 "alpha")))))
   ()
   ()
   (("E" 25 . ,(lambda (term) (make-term-in-app-form (make-term-in-const-form (finalg-to-e-const (term-to-type term))) term)))("bot" 7 . ,(cons (make-arity) "bot")))
   (("exnc" 44 . ,(lambda (v k) (apply mk-exnc (append v (list k)))))("Equal" 10 . ,(string-and-arity-to-predconst-parse-function "Equal" (make-arity (make-tvar -1 "alpha") (make-tvar -1 "alpha")))))
   (("Rec" 26 . ,(lambda (l) (make-term-in-const-form (apply type-info-to-rec-const l)))))
   ()
   ()
   (("^_" 53))
   ()
   ()
   (("'_" 54)("prop" 4 . ,"prop"))
   ()
   (("right" 25 . ,make-term-in-rcomp-form))
   ()
   ()
   ()
   ()
   (("PREFIXOP" 78 . ,(list (quote prefix-op) "PREFIXOP" 1)))
   ()
   (("->" 43 . ,make-imp))
   ()
   (("exca" 44 . ,(lambda (v k) (apply mk-exca (append v (list k)))))("all" 44 . ,(lambda (v k) (apply mk-all (append v (list k))))))
   ()
   (("nulltype" 4 . ,"nulltype"))
   (("[" 57))
   ()
   (("]" 58))
   (("^" 46))
   (("_" 47)("alpha" 3 . ,"alpha"))
   (("PRED" 72))
  ))

; *** Lexer Definition ***
(define lexer
   (make-lexer
    terminal-table
    token-nrs
))


; *** Shortcut Definition ***
(define (pf string)
   (parser (lexer (string-reader string)) myerror))


(define (parse-file filename)
  (let ((parse-port
    (lambda (port)
      (parser (lexer (port-reader filename port)) myerror))))
    (call-with-input-file filename parse-port)))


; *** Add-Token Definition ***
(define add-token
   (make-add-token
    terminal-table
    token-nrs
))

; *** Remove-Token Definition ***
(define remove-token
   (make-remove-token
    terminal-table
    token-nrs
))

; *** Is-Token? Definition ***
(define is-token?
   (make-is-token?
    terminal-table
    token-defs
))

; *** Display-Tokens Definition ***
(define (display-tokens)
   (lexer-info
    terminal-table
    token-nrs
))

